﻿XIncludeFile "sdl.pbi"

SDL_Init_(#SDL_INIT_EVERYTHING)

Procedure InitializeSDL_version(*SDL_versionA.SDL_version)
*Version.SDL_version = SDL_Linked_Version_()
CopyMemory(*Version, *SDL_versionA, SizeOf(SDL_version))
EndProcedure

Macro Format_SDL_Version(SDL_VersionA)
  "SDL Runtime Version : " + StrU(SDL_VersionA\major, #PB_Byte) + "." + StrU(SDL_VersionA\minor, #PB_Byte) + "." + StrU(SDL_VersionA\patch, #PB_Byte)
EndMacro

InitializeSDL_version(SDL_version.SDL_version)
Debug Format_SDL_Version(SDL_Version)

Structure sample
  daten.l
  pos.l
  len.l
EndStructure

Global sound.sample
Global wanted.SDL_AudioSpec

Procedure audiomix(*na, *stream, laenge)
  menge = sound\len - sound\pos
  ;sound\daten = sound\pos
  If ( menge > laenge)
    menge = leange
  EndIf
  SDL_MixAudio_(stream, @sound\daten, menge, #SDL_MIX_MAXVOLUME)
  sound\pos + menge
EndProcedure

Procedure play_audio(datei.s)
  Protected index.i = 0
  Protected wave.SDL_AudioSpec
  Protected *daten
  Protected len.l
  Protected *cvt.SDL_AudioCVT
  Protected format.SDL_AudioSpec
  
  Debug "Filesize: "+ Str(FileSize(datei))
  
  *snd = AllocateMemory(FileSize(datei)) ;einfach mal so
  
  Debug datei
  
  If ( SDL_LoadWav_(PokeS(*snd, datei), @wave, @daten, @len) = #Null )
    Debug "Wav is loaded !"
    SDL_BuildAudioCVT_(@cvt, wave\format, wave\channels, wave\freq, #AUDIO_S16, 2, 44100)
    *cvt\buf = AllocateMemory(len * *cvt\len_mult)
    CopyMemory(*cvt\buf, *daten, len)
    *cvt\len = len
    SDL_ConvertAudio_(@cvt)
    SDL_FreeWAV_(*daten)
    SDL_LockAudio_()
    sound\daten = *cvt\buf
    sound\len = *cvt\len_cvt
    sound\pos = 0
    SDL_UnlockAudio_()
  EndIf
EndProcedure

Procedure.i eventloop()
  event.SDL_Event
  While ( SDL_WaitEvent_(@event) )
    keysym.SDL_keysym
    Select event\type
      Case #SDL_KEYDOWN
        keysym = event\key\keysym
        If ( keysym\sym = #SDLK_ESCAPE )
          Debug "ESCAPE gedrückt."
          End
        EndIf
        If ( keysym\sym = #SDLK_SPACE )
          Debug "Leertaste gedrückt."
          fsound.s = OpenFileRequester("MusikSuche", "", "*.*", 0)
          play_audio(fsound)
        EndIf
      Case #SDL_QUIT
        Debug "Quit event. Bye."
        Break
    EndSelect
  Wend
EndProcedure

Procedure Main()
  screen.SDL_Surface
  done = 1
  format.SDL_AudioSpec
  
  If ( SDL_Init_(#SDL_INIT_VIDEO | #SDL_INIT_AUDIO ) <> 0 )
    Debug "Unable to initialize SDL."
    End
  EndIf
  SDL_SetVideoMode_(256, 256, 16, 0)
  If ( screen = #Null )
    Debug "Unable to set video mode."
    End
  EndIf
  
  format\freq = 22050
  format\format = #AUDIO_S16
  format\channels = 2
  format\samples = 512
  format\callback = audiomix(#Null, sound\daten, sound\len) 
  format\userdata = #Null
  
  If ( SDL_OpenAudio_(@format, #Null) < 0 )
    Debug "Audio-Gerät konnte nicht geöffnet werden."
  EndIf
  
  SDL_PauseAudio_(0)
  
  While (done)
    Debug "ESC für Ende und Leertaste für Sound"
    done = eventloop()
  Wend
  
  SDL_PauseAudio_(1)
  SDL_CloseAudio_()
EndProcedure

Main()
End
; IDE Options = PureBasic 5.61 (Linux - x64)
; CursorPosition = 107
; Folding = --
; EnableXP